import time, re

def findStringInMyStringList(main_list, sublist, start_index=0, direction=1):
    start_index = max(0, min(start_index, len(main_list) - 1))

    if direction == 1: # forward
        for index in range(start_index+1, len(main_list)):
            if main_list[index].data() == sublist:
                return index
    else:  # backward
        for index in range(start_index-1, -1, -1):
            if main_list[index].data() == sublist:
                return index
    return -1

def ExtracrtNumBeforeLastKey(s):
    numbers_list = list(re.finditer(r'\d+', s))
    if numbers_list:
        last_number_match = numbers_list[-1]
        number = last_number_match.group()
        i = last_number_match.start()
        if i + len(number) == len(s) - 1:
            return int(number), i
    return None, None

def isAscii(symbolCode: int) -> bool:
    return 32 <= symbolCode <= 126

def UnixSec() -> int:
    return int(time.time())